package org.processmining.dataawarereplayer.precision.state;



public final class PrecisionStateImpl implements PrecisionState {

	private final TraceState traceState;
	private final ModelState modelState;

	public PrecisionStateImpl(TraceState traceState, ModelState modelState) {
		this.traceState = traceState;
		this.modelState = modelState;
	}
	
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((modelState == null) ? 0 : modelState.hashCode());
		result = prime * result + ((traceState == null) ? 0 : traceState.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PrecisionStateImpl other = (PrecisionStateImpl) obj;
		if (modelState == null) {
			if (other.modelState != null)
				return false;
		} else if (!modelState.equals(other.modelState))
			return false;
		if (traceState == null) {
			if (other.traceState != null)
				return false;
		} else if (!traceState.equals(other.traceState))
			return false;
		return true;
	}

	public String toString() {	
		return String.format("%s (%s)", traceState, modelState);
	}

	public ModelState getModelState() {
		return modelState;
	}

	public TraceState getTraceState() {
		return traceState;
	}

}
