package org.processmining.dataawarereplayer.precision.state;

import java.util.List;

import org.processmining.dataawarereplayer.precision.projection.ProjectedEvent;

import com.google.common.base.Joiner;

public final class TraceStatePrefixImpl implements TraceState {

	private final List<ProjectedEvent> prefix;

	public TraceStatePrefixImpl(List<ProjectedEvent> prefix) {
		this.prefix = prefix;
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((prefix == null) ? 0 : prefix.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TraceStatePrefixImpl other = (TraceStatePrefixImpl) obj;
		if (prefix == null) {
			if (other.prefix != null)
				return false;
		} else if (!prefix.equals(other.prefix))
			return false;
		return true;
	}

	public String toString() {
		return Joiner.on(',').join(prefix);
	}

	public List<ProjectedEvent> getPrefix() {
		return prefix;
	}
}
