package org.processmining.plugins.DataConformance.DataAlignment;

import java.util.ArrayList;

import org.deckfour.xes.model.XTrace;

public class ControlFlowAlignment extends ArrayList<IControlFlowAlignmentStep<Object, Object>> implements IControlFlowAlignment<Object, Object> {

	private static final long serialVersionUID = 1L;
	
	private final String traceName;
	private final float controlFlowFitness;

	public ControlFlowAlignment(String traceName, float controlFlowFitness) {
		this.traceName=traceName;
		this.controlFlowFitness=controlFlowFitness;
	}
	
	public ControlFlowAlignment(String traceName, float controlFlowFitness, int initialCapacity) {
		super(initialCapacity);
		this.traceName=traceName;
		this.controlFlowFitness=controlFlowFitness;
	}

	public String getTraceName() {
		return traceName;
	}

	public float getControlFlowFitness() {
		return controlFlowFitness;
	}

	public XTrace getTrace() {
		throw new UnsupportedOperationException("This class does not yet support getTrace()");
	}

}
