package org.processmining.plugins.DataConformance.GUI;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;
import java.util.Set;

import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.processmining.plugins.DataConformance.framework.ActivityMatchCosts;
import org.processmining.plugins.DataConformance.framework.ReplayableActivity;

import com.fluxicon.slickerbox.components.SlickerButton;
import com.fluxicon.slickerbox.factory.SlickerFactory;

class ActivityMatchCostListener implements ActionListener
{
	ActivityMatchCostPanel panel;
	static String ADDMATCH="A";
	static String REMOVEMATCH="R";
	
	public ActivityMatchCostListener(ActivityMatchCostPanel activityMatchCostPanel) {
		panel=activityMatchCostPanel;
	}

	public void actionPerformed(ActionEvent e) 
	{
		if (e.getActionCommand()==ADDMATCH)
			panel.activityCostTable.addRow();
		else if (e.getActionCommand()==REMOVEMATCH)
			panel.activityCostTable.removeRow();
	}
}

public class ActivityMatchCostPanel<E> extends JPanel
{
	private JPanel sudPanel=new JPanel();
	private SlickerButton addButton=new SlickerButton("Add matching");
	private SlickerButton removeButton=new SlickerButton("Remove matching");
	ActivityMatchingCostTable<E> activityCostTable=null;
	private ActivityMatchCostListener listener= new ActivityMatchCostListener(this);
	private Set<? extends ReplayableActivity> activities;
	private Map<? extends ReplayableActivity, E> activityMapping;
	private JCheckBox heuristicCBox=null;

	
	public ActivityMatchCostPanel(Set<? extends ReplayableActivity> activities, Map<? extends ReplayableActivity, E> activityMapping)
	{
		this.setLayout(new BorderLayout());
		this.activities=activities;
		this.activityMapping=activityMapping;
		activityCostTable=new ActivityMatchingCostTable<E>(activities,activityMapping.values());
		JScrollPane jsp=new JScrollPane(activityCostTable);
		jsp.setPreferredSize(new Dimension(122,187));
		sudPanel.add(addButton);
		addButton.addActionListener(listener);
		addButton.setActionCommand(ActivityMatchCostListener.ADDMATCH);
		sudPanel.add(removeButton);
		removeButton.addActionListener(listener);
		removeButton.setActionCommand(ActivityMatchCostListener.REMOVEMATCH);		
		this.add(jsp,BorderLayout.CENTER);
		this.add(sudPanel,BorderLayout.SOUTH);

	}
	
	public ActivityMatchCostPanel(Set<? extends ReplayableActivity> activities, Map<? extends ReplayableActivity, E> activityMapping, 
			String specialOptionText) {
		this(activities,activityMapping);
		heuristicCBox = SlickerFactory.instance().createCheckBox(specialOptionText, true);
		this.add(heuristicCBox,BorderLayout.NORTH);		
	}

	public ActivityMatchCosts<E> getCosts()
	{
		return new ActivityMatchCosts<E>(activities,activityMapping,activityCostTable.model.getValues());
	}
	
	public boolean specialOptionOn()
	{
		if (heuristicCBox==null)
			return false;
		else
			return heuristicCBox.isSelected();
	}
}
