package org.processmining.plugins.DataConformance.framework;

import java.util.ArrayList;
import java.util.Collection;

public class LogExecutionTrace extends ExecutionTrace 
{
	private ExecutionTrace completeTrace;
	private String traceName=null;
	
	public LogExecutionTrace(ExecutionTrace completeTrace) {
		super(1);
		setUp(completeTrace);
	}
	
	private void setUp(ExecutionTrace completeTrace) {
		this.completeTrace=completeTrace;
		if (completeTrace instanceof LogExecutionTrace)
			this.traceName=completeTrace.getTraceName();		
	}
	
	private LogExecutionTrace(int capacity) { 
		super(capacity);
	}
	
	public LogExecutionTrace(String traceName) {
		this((ExecutionTrace)null);
		this.traceName=traceName;
	}

	public Collection<ExecutionTrace> successors(ExecutionStep activity) 
	{
		int eventInThePrefix=lengthExecutionTraceWithoutBottomSteps();
		ArrayList<ExecutionTrace> retValue=new ArrayList<ExecutionTrace>(2);
		if (eventInThePrefix<completeTrace.size())
		{
			ExecutionStep eventToAdd=completeTrace.get(eventInThePrefix);
			ExecutionTrace successor1=(ExecutionTrace) this.clone();
			successor1.add(eventToAdd);
			
			retValue.add(successor1);
			
		}
		LogExecutionTrace successorTau=(LogExecutionTrace) this.clone();
		successorTau.add(ExecutionStep.bottomStep);
		retValue.add(successorTau);
		return retValue;	
	}

	public boolean isComplete() 
	{
		short alignedPrefix=(short) (this.size()-numberOfBottomSteps);
		return (alignedPrefix==completeTrace.size());
	}

	public String getTraceName() {
		return traceName;
	}
	
	public Object clone() {
		LogExecutionTrace clone=new LogExecutionTrace(this.size()+1);
		clone.setUp(completeTrace);
		clone.addAll(this,numberOfBottomSteps);
		return clone;
	}

	public ExecutionTrace removeBottomEvent() {
		LogExecutionTrace retValue=new LogExecutionTrace(this.size()-numberOfBottomSteps);
		for(ExecutionStep step : this)
			if (!step.equals(ExecutionStep.bottomStep))
				retValue.add(step);
		return retValue;
	}
	
}
