package org.processmining.plugins.DataConformance.test;

import java.util.HashSet;
import java.util.Set;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMPropertiesPanel;
import org.processmining.framework.util.ui.widgets.ProMTextField;
import org.processmining.models.DCNet.DCNet;
import org.processmining.models.DCNet.DCNetNode;


public class ExampleBIS 
{
/*	@Plugin(name = "Data-aware Casual Net Generator",
			parameterLabels = {},
			returnLabels = { "Data-aware Casual Net"},
			returnTypes = { DCNet.class },
			userAccessible = true,
			help = "Data-aware Casual Net Generator")
			@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "M. de Leoni", email = "m.d.leoni@tue.nl")*/
	public static DCNet dataConformance(UIPluginContext context) 
	{
		
		ProMPropertiesPanel myPanel=new ProMPropertiesPanel("Configuration");
		ProMTextField nTxt=new ProMTextField();
		ProMTextField mTxt=new ProMTextField();
		ProMTextField perVarTxt=new ProMTextField("100");
		myPanel.addProperty("Number of parallel activities", nTxt);
		myPanel.addProperty("Size of the domain of each variable", mTxt);
		myPanel.addProperty("Percentage of variables", perVarTxt);
		
		context.showConfiguration("Parameters", myPanel);
		
		int n=Integer.parseInt(nTxt.getText());
		int m=Integer.parseInt(mTxt.getText());
		int div=100/Integer.parseInt(perVarTxt.getText());
		int numVar=0;
		DCNet instance=new DCNet("BIS Example with N="+n+" and M="+m);

		instance.setLengthShortestTrace(4+n);		
		
		Integer values[]=new Integer[m+1];
		for(int i=0;i<=m;i++) {
			values[i]=i;
		}
		
		//instance.addSet("Values");
		instance.addValuesToSet("Values", values);
		
		
		DCNetNode nodeS=new DCNetNode("S");
		instance.addNode(nodeS);
		DCNetNode nodeO=new DCNetNode("O");
		instance.addNode(nodeO);
		Set<DCNetNode> S_OUT=new HashSet<DCNetNode>();
		String mean="";
		for(int i=1;i<=n;i++) {
			instance.addVariable("X"+i, "Values");
			DCNetNode nodeAi=new DCNetNode("A"+i);
			if ((i-1) % div == 0)
			{
				nodeAi.setGuard("$X"+i+">=0");
				if (i<n)
					mean+="(";
				mean+="X"+i;
				numVar++;
				if (i<n) mean+="+";
			}
			instance.addNode(nodeAi);
			S_OUT.add(nodeAi);
			instance.addInputBinding(nodeAi, "",nodeS);
			instance.addOutputBinding(nodeAi, "", nodeO);			
		}
		for(int i=1;i<n;i++)
			mean+=")";
		mean="("+mean+"/"+numVar+")";
		
		instance.addOutputBinding(nodeS, "", S_OUT);
		instance.addInputBinding(nodeO, "", S_OUT);
		
		float bcGuard = (float) (m*0.5);

		
		DCNetNode nodeB=new DCNetNode("B");
		instance.addNode(nodeB);
		nodeB.setGuard(mean+" < "+bcGuard);
		instance.addOutputBinding(nodeO, "",nodeB);
		instance.addInputBinding(nodeB, "", nodeO);
		DCNetNode nodeC=new DCNetNode("C");
		nodeC.setGuard(mean+" >= "+bcGuard);
		instance.addNode(nodeC);
		instance.addOutputBinding(nodeO, "",nodeC);
		instance.addInputBinding(nodeC, "", nodeO);
		
		DCNetNode nodeZ=new DCNetNode("Z");
		instance.addNode(nodeZ);
		instance.addOutputBinding(nodeB, "",nodeZ);
		instance.addOutputBinding(nodeC, "",nodeZ);
		instance.addInputBinding(nodeZ, "",nodeC);
		instance.addInputBinding(nodeZ, "",nodeB);

		instance.setStartNode(nodeS);
		instance.setEndNode(nodeZ);
		
		return instance ;
	}
}
