package org.processmining.plugins.DataConformance.visualization;

import java.util.Arrays;
import java.util.Map;

import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;

import org.processmining.plugins.DataConformance.ResultReplay;

/*It associates an attribute to a 4-element tuple: 
	- the first element is the number of times the attribute should have been written 
	- the second element is the number of times the attribute hasn't been written 
	- the third is the mean value of the deviation 
	- the fourth is the variance of the deviation*/


public class AttributeTableModel implements TableModel {
	Object[][] table; 

	public AttributeTableModel(ResultReplay logReplayResult) {
		Map<String, float[]> attrArray=logReplayResult.attrArray;
		String[] keys=attrArray.keySet().toArray(new String[0]);
		Arrays.sort(keys);
		table=new Object[keys.length][4];
		for(int i=0;i<keys.length;i++) {
			float[] val=attrArray.get(keys[i]);
			table[i][0]=keys[i];
			table[i][1]=100F*(val[1]/val[0])+" %";
			table[i][2]=val[2];			
			table[i][3]=val[3];			
		}
		
	}

	public void addTableModelListener(TableModelListener arg0) { }

	public Class<?> getColumnClass(int arg0) {
		if (arg0<=1)
			return String.class;
		else
			return Float.class;
	}

	public int getColumnCount() {
		// TODO Auto-generated method stub
		return 4;
	}

	public String getColumnName(int arg0) {
		switch(arg0)
		{
			case 0:
				return "Attribute Name";
			case 1:
				return "Steps With Missing Value Assignments";
			case 2:
				return "Average Assignment Difference";
			case 3:
				return "Standard Deviation";
			default:
				return "";
		}
	}

	public int getRowCount() {
		// TODO Auto-generated method stub
		return table.length;
	}

	public Object getValueAt(int arg0, int arg1) {
		return table[arg0][arg1];
	}

	public boolean isCellEditable(int arg0, int arg1) {
		return false;
	}

	public void removeTableModelListener(TableModelListener arg0) {	}

	public void setValueAt(Object arg0, int arg1, int arg2) {	}

}
