package org.processmining.plugins.DataConformance.visualization;

import java.awt.Color;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.DCNet.visualization.DCNetV;
import org.processmining.models.DCNet.visualization.DCNetVisualization;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.ViewSpecificAttributeMap;
import org.processmining.models.jgraph.ProMJGraphVisualizer;
import org.processmining.models.visualcnet.CNetVNode;
import org.processmining.plugins.DataConformance.DCnet.ResultReplayDCNet;


@Plugin(name = "Projection of the alignment onto Casual Nets", returnLabels = { "Projection of the alignment onto Casual Nets" }, 
		returnTypes = { JComponent.class }, parameterLabels = { "Matching Instances" }, userAccessible = false)
@Visualizer
public class ReplayResultDCNetVis {
	@SuppressWarnings("unchecked")
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, ResultReplayDCNet logReplayResult) {
		ViewSpecificAttributeMap viewSpecificMap=new ViewSpecificAttributeMap();
		DCNetV graph=DCNetVisualization.generateJGraph(logReplayResult.getNet(), viewSpecificMap);
		for(CNetVNode node : graph.getNodes())
		{
			float actArray[]=logReplayResult.actArray.get(node.getNode().getLabel());
			float redVariation=actArray[0]/(actArray[0]+actArray[1]);
			Color fillColor=new Color(1-redVariation, redVariation, 0);
			node.getAttributeMap().put(AttributeMap.FILLCOLOR, fillColor);
		}
		return ProMJGraphVisualizer.instance().visualizeGraph(context, graph, viewSpecificMap);
	}
}
