package org.processmining.plugins.DataConformance.visualization.comparison;

import java.awt.Color;

import org.processmining.framework.util.ui.widgets.traceview.ProMTraceView.AbstractSplittedEvent;
import org.processmining.plugins.DataConformance.framework.ExecutionStep;
import org.processmining.plugins.DataConformance.visualization.DataAwareStepTypes;

public class SplittedDataAlignmentEvent extends AbstractSplittedEvent {

	private static final Color MISMATCH_COLOR = Color.RED;
	private static final String NOMOVE = ">>";
	
	private ExecutionStep processStepA;
	private ExecutionStep logStepA;
	private DataAwareStepTypes typeA;
	
	private ExecutionStep processStepB;
	private ExecutionStep logStepB;
	private DataAwareStepTypes typeB;
	
	public SplittedDataAlignmentEvent(ExecutionStep processStepA, ExecutionStep logStepA, DataAwareStepTypes typeA,
			ExecutionStep processStepB, ExecutionStep logStepB, DataAwareStepTypes typeB) {
				this.processStepA = processStepA;
				this.logStepA = logStepA;
				this.typeA = typeA;
				this.processStepB = processStepB;
				this.logStepB = logStepB;
				this.typeB = typeB;
	}
	
	private static String buildLabel(ExecutionStep processStep, ExecutionStep logStep) {
		if (processStep == null || logStep == null) {
			return null;
		} else if (processStep.getActivity() != null) {
			return processStep.getActivity();
		} else if (logStep.getActivity() != null) {
			return logStep.getActivity();
		} else {
			return NOMOVE;
		}
	}

	public String getUpperLabel() {
		return buildLabel(processStepA, logStepA);
	}

	public Color getUpperColor() {
		return (processStepA != null || logStepA != null) ? typeA.getColor() : MISMATCH_COLOR;
	}

	public String getLowerLabel() {
		return buildLabel(processStepB, logStepB);
	}

	public Color getLowerColor() {
		return (processStepB != null || logStepB != null) ? typeB.getColor() : MISMATCH_COLOR;
	}
	
	

}
