package org.processmining.plugins.balancedconformance.functions.impl;

enum TimeResolution {

	MILLISECONDS(1l, "ms"), // 
	SECONDS(1000l, "s"), //
	MINUTES(1000l * 60l, "m"), // 
	HOURS(1000l * 60l * 60l, "h"), //
	DAYS(1000l * 60l * 60l * 24l, "d");

	private final long factor;
	private final String unit;

	private TimeResolution(long millisecondFactor, String unit) {
		this.factor = millisecondFactor;
		this.unit = unit;
	}

	public long getFactor() {
		return factor;
	}

	public String getUnit() {
		return unit;
	}

	public String toString() {
		return getUnit();
	}

	public static TimeResolution fromUnit(String resolution) {
		switch (resolution) {
			case "ms" :
				return MILLISECONDS;
			case "s" :
				return SECONDS;
			case "m" :
				return MINUTES;
			case "h" :
				return HOURS;
			case "d" :
				return DAYS;
			default :
				return SECONDS;
		}
	}

}